unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, IniFiles, Buttons, StrUtils;

type
  TFormTag = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    CheckArtistv1: TCheckBox;
    LabelArtistv1: TEdit;
    LabelAlbumv1: TEdit;
    CheckAlbumv1: TCheckBox;
    LabelTitrev1: TEdit;
    CheckTitrev1: TCheckBox;
    LabelAnneev1: TEdit;
    CheckAnneev1: TCheckBox;
    CheckComv1: TCheckBox;
    LabelComv1: TMemo;
    LabelArtistv2: TEdit;
    LabelAlbumv2: TEdit;
    LabelTitrev2: TEdit;
    LabelAnneev2: TEdit;
    LabelComv2: TMemo;
    CheckArtistv2: TCheckBox;
    CheckAlbumv2: TCheckBox;
    CheckTitrev2: TCheckBox;
    CheckAnneev2: TCheckBox;
    CheckComv2: TCheckBox;
    Progression: TProgressBar;
    Btnv1v2: TButton;
    Btnv2v1: TButton;
    LabelNbv2: TEdit;
    CheckNbv2: TCheckBox;
    BtnSave: TBitBtn;
    BtnClose: TBitBtn;
    CheckAutoNbv2: TCheckBox;
    ComboGenrev1: TComboBox;
    CheckGenrev1: TCheckBox;
    ComboGenrev2: TComboBox;
    CheckGenrev2: TCheckBox;
    GroupBox3: TGroupBox;
    LabelInfos: TLabel;
    CheckNbv1: TCheckBox;
    CheckAutoNbv1: TCheckBox;
    LabelNbv1: TEdit;
    GroupBox4: TGroupBox;
    ComboBox1: TComboBox;
    procedure BtnSaveClick(Sender: TObject);
    procedure MiseAJours;
    procedure CheckClick(Sender: TObject);
    procedure BtnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Traitement(Index: integer);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormTag : TFormTag;
  F       : String;
  Fs      : TStringList;

implementation

uses Unit1, Unit2, ID3v1, ID3v2, Bass, DeKiBulleUtils, InfoMPEG, InfoOGG;

{$R *.dfm}

//============================================================================//
{                  Mis a jours de la liste                                     }
//----------------------------------------------------------------------------//
procedure TFormTag.MiseAJours;
var
    MP3Tag  : TagMP3;
    MP3Tag2 : TID3v2;
    OGGTag  : InfosOGG;
    Ext     : string;
    i       : integer;
    Preums  : boolean;
begin
    Screen.Cursor    := crHourGlass;
    BtnSave.Enabled  := False;
    Btnv1v2.Enabled  := False;
    Btnv2v1.Enabled  := False;
    BtnClose.Enabled := False;

            { R A Z }
    ComboBox1.Clear;
    LabelInfos.Caption := '';

    LabelArtistv1.Clear;
    LabelAlbumv1.Clear;
    LabelTitrev1.Clear;
    LabelAnneev1.Clear;
    LabelNbv1.Clear;
    LabelComv1.Clear;
    ComboGenrev1.ItemIndex := -1;

    LabelArtistv2.Clear;
    LabelAlbumv2.Clear;
    LabelTitrev2.Clear;
    LabelAnneev2.Clear;
    LabelNbv2.Clear;
    LabelComv2.Clear;
    ComboGenrev2.Text := '';

    CheckArtistv1.Checked := true;
    CheckAlbumv1.Checked  := true;
    CheckTitrev1.Checked  := true;
    CheckAnneev1.Checked  := true;
    CheckGenrev1.Checked  := true;
    CheckNbv1.Checked     := true;
    CheckAutoNbv1.Checked := false;
    CheckComv1.Checked    := true;

    CheckArtistv2.Checked := true;
    CheckAlbumv2.Checked  := true;
    CheckTitrev2.Checked  := true;
    CheckAnneev2.Checked  := true;
    CheckGenrev2.Checked  := true;
    CheckNbv2.Checked     := true;
    CheckAutoNbv2.Checked := false;
    CheckComv2.Checked    := true;

    CheckClick(nil);

            { cre la liste des fichiers mp3 }
    Fs := TStringList.Create;
    With Form1 do
      for i := 0 to ListBox1.Count - 1 do
        if (ListBox1.Selected[i]) and (FileExists(ListeLecture.Strings[i])) then
        begin
          Ext := LowerCase(ExtractFileExt(ListeLecture.Strings[i]));
          if AnsiContainsText('$.mp3$.mp2$.mpc$.ogg$', Ext) then
            Fs.Add(ListeLecture.Strings[i]);
        end;

    Preums := True;
    With Progression do
    begin
        Position := 0;
        Max := Fs.Count * 2;
    end;
    MP3Tag2 := TID3v2.Create;

            { lit les infos }
    for i := 0 to Fs.Count - 1 do
    begin
      F := Fs.Strings[i];
      Progression.Position := i * 2;
      ComboBox1.Items.Add(ExtractFileName(F));
      Ext := LowerCase(ExtractFileExt(F));

            { Lecture TAG ID3 v1 }
      if AnsiContainsText('$.mp3$.mp2$.mpc$', Ext) then
      begin
        MP3Tag := Lire_Tag(F);
        With MP3Tag do
        begin
            if Preums then
            begin
                LabelArtistv1.Text     := Artiste;
                LabelAlbumv1.Text      := Album;
                LabelTitrev1.Text      := Titre;
                LabelAnneev1.Text      := Annee;
                LabelNbv1.Text         := Format('%.2d', [TrackNb]);;
                LabelComv1.Text        := Commentaire;
                ComboGenrev1.ItemIndex := Genre;
            end else begin
                if Artiste     <> LabelArtistv1.Text     then CheckArtistv1.Checked   := False;
                if Album       <> LabelAlbumv1.Text      then CheckAlbumv1.Checked    := False;
                if Titre       <> LabelTitrev1.Text      then CheckTitrev1.Checked    := False;
                if Annee       <> LabelAnneev1.Text      then CheckAnneev1.Checked    := False;
                if Format('%.2d', [TrackNb]) <> LabelNbv1.Text then CheckNbv1.Checked := False;
                if Commentaire <> LabelComv1.Text        then CheckComv1.Checked      := False;
                if Genre       <> ComboGenrev1.ItemIndex then CheckGenrev1.Checked    := False;
            end;
        end;
      end;

            { Lecture TAG ID3 v2 }
      if AnsiContainsText('$.mp3$.mp2$', Ext) then
      begin
        With MP3Tag2 do
        begin
            ReadFromFile(F);
            if Exists then
            begin
                if Preums then
                begin
                    LabelArtistv2.Text := Artist;
                    LabelAlbumv2.Text  := Album;
                    LabelTitrev2.Text  := Title;
                    LabelAnneev2.Text  := Year;
                    LabelNbv2.Text     := Format('%.2d', [Track]);
                    LabelComv2.Text    := Comment;
                    ComboGenrev2.Text  := Genre;
                end else begin
                    if Artist  <> LabelArtistv2.Text then CheckArtistv2.Checked := False;
                    if Album   <> LabelAlbumv2.Text  then CheckAlbumv2.Checked  := False;
                    if Title   <> LabelTitrev2.Text  then CheckTitrev2.Checked  := False;
                    if Year    <> LabelAnneev2.Text  then CheckAnneev2.Checked  := False;
                    if Format('%.2d', [Track]) <> LabelNbv2.Text then CheckNbv2.Checked  := False;
                    if Comment <> LabelComv2.Text    then CheckComv2.Checked    := False;
                    if Genre   <> ComboGenrev2.Text  then CheckGenrev2.Checked  := False;
                end;
            end;
        end;
      end;

            { Lecture TAG OGG }
      if AnsiContainsText('$.ogg$', Ext) then
      begin
        OGGTag := LireInfosOGG(F);
        With OGGTag do
        begin
            if Preums then
            begin
                LabelArtistv2.Text := Artist;
                LabelAlbumv2.Text  := Album;
                LabelTitrev2.Text  := Title;
                LabelAnneev2.Text  := Date;
                LabelNbv2.Text     := Track;
                LabelComv2.Text    := Comment;
                ComboGenrev2.Text  := Genre;
            end else begin
                if Artist  <> LabelArtistv2.Text then CheckArtistv2.Checked := False;
                if Album   <> LabelAlbumv2.Text  then CheckAlbumv2.Checked  := False;
                if Title   <> LabelTitrev2.Text  then CheckTitrev2.Checked  := False;
                if Date    <> LabelAnneev2.Text  then CheckAnneev2.Checked  := False;
                if Track   <> LabelNbv2.Text     then CheckNbv2.Checked     := False;
                if Comment <> LabelComv2.Text    then CheckComv2.Checked    := False;
                if Genre   <> ComboGenrev2.Text  then CheckGenrev2.Checked  := False;
            end;
        end;
      end;
      CheckClick(nil);
      if Preums then Preums := False;
    end;
    MP3Tag2.Free;

            { Lecture des Infos MPEG et OGG }
    if Fs.Count = 1 then
    begin
        if AnsiContainsText('$.mp3$.mp2$', Ext) then
            LabelInfos.Caption := TexteInfosMPEG(F)
        else if AnsiContainsText('$.ogg$', Ext) then
            LabelInfos.Caption := TexteInfosOGG(F)
        else
            LabelInfos.Caption := '...';
    end else begin
        LabelInfos.Caption := '...';
        ComboBox1.Items.Insert(0, IntToStr(Fs.Count) + ' file(s)');
    end;
    ComboBox1.ItemIndex := 0;

    Progression.Position := 0;
    if Fs.Count > 0 then
    begin
        BtnSave.Enabled := True;
        Btnv1v2.Enabled := True;
        Btnv2v1.Enabled := True;
    end;
    BtnClose.Enabled := True;
    Screen.Cursor    := crDefault;
end;

//============================================================================//
{                  Activation / Dsactivation des boites de texte              }
//----------------------------------------------------------------------------//
procedure TFormTag.CheckClick(Sender: TObject);
begin
            { on active ou pas les boites de texte }
    LabelArtistv1.Enabled := CheckArtistv1.Checked;
    LabelAlbumv1.Enabled  := CheckAlbumv1.Checked;
    LabelTitrev1.Enabled  := CheckTitrev1.Checked;
    LabelAnneev1.Enabled  := CheckAnneev1.Checked;
    LabelNbv1.Enabled     := CheckNbv1.Checked and Not(CheckAutoNbv1.Checked);
    CheckAutoNbv1.Enabled := CheckNbv1.Checked;
    LabelComv1.Enabled    := CheckComv1.Checked;
    ComboGenrev1.Enabled  := CheckGenrev1.Checked;

    LabelArtistv2.Enabled := CheckArtistv2.Checked;
    LabelAlbumv2.Enabled  := CheckAlbumv2.Checked;
    LabelTitrev2.Enabled  := CheckTitrev2.Checked;
    LabelAnneev2.Enabled  := CheckAnneev2.Checked;
    LabelNbv2.Enabled     := CheckNbv2.Checked and Not(CheckAutoNbv2.Checked);
    CheckAutoNbv2.Enabled := CheckNbv2.Checked;
    LabelComv2.Enabled    := CheckComv2.Checked;
    ComboGenrev2.Enabled  := CheckGenrev2.Checked;
end;

//============================================================================//
{                  Bouton Fermer                                               }
//----------------------------------------------------------------------------//
procedure TFormTag.BtnCloseClick(Sender: TObject);
begin
    Close;
end;

//============================================================================//
{                  Lors de la fermeture de la Form                             }
//----------------------------------------------------------------------------//
procedure TFormTag.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Fs.Free;
end;

//============================================================================//
{                  Lors de l'affichage de la Form                              }
//----------------------------------------------------------------------------//
procedure TFormTag.FormShow(Sender: TObject);
begin
            { On cache la Form1 (sinon elle reste devant...) }
    Form1.CacheForm(True);
            { Gestion de la langue }
    GestionLangue(3);
    //SetCursorPos(Left + Width div 2, Top + 10); // On dplace la souris
end;

//============================================================================//
{     Bouton "Enregistrer", "copier v1 vers v2" ou "copier v2 vers v1"         }
//----------------------------------------------------------------------------//
procedure TFormTag.BtnSaveClick(Sender: TObject);
var
    IniLangue: Tinifile;
begin
    IniLangue := TiniFile.Create(FichierLangue);
    if MessageDlg(IniLangue.ReadString('MESSAGES', '11', ''), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
        with (Sender as TButton) do begin
            if Name = 'BtnSave' then
                Traitement(0)
            else if Name = 'Btnv1v2' then
                Traitement(12)
            else
                Traitement(21);
        end;
        Close;
    end;
    IniLangue.Free;
end;

//============================================================================//
{                  Traitemens des actions (sauver, copier)                     }
//----------------------------------------------------------------------------//
procedure TFormTag.Traitement(Index: integer);
var
    MP3Tag    : TagMP3;
    MP3Tag2   : TID3v2;
    OGGTag    : InfosOGG;
    Ext       : string;
    i         : integer;
    Lect      : Boolean;
    IndexLect : Integer;
begin
    Screen.Cursor    := crHourGlass;
    BtnSave.Enabled  := False;
    Btnv1v2.Enabled  := False;
    Btnv2v1.Enabled  := False;
    BtnClose.Enabled := False;
    FormTag.Enabled  := False;
    Progression.Position := 0;
    IndexLect        := Form1.IndexMP3;
    MP3Tag2          := TID3v2.Create;
    With LabelNbv1 do if Text = '' then Text := '0';
    With LabelNbv2 do if Text = '' then Text := '0';

    For i := 0 to Fs.Count - 1 do
    begin
        F := Fs.Strings[i];
        if FileExists(F) and ((FileGetAttr(F) and faReadOnly) = 0) then
        begin
            With Form1 do
            begin
                    { Si le fichier est en cours de lecture on pause }
                if (IndexLect > -1) and (F = ListeLecture.Strings[IndexLect]) and Timer2.Enabled then
                begin
                    Lect := True;
                    PauseFichier;
                end else
                    Lect := False;
            end;

            Ext := LowerCase(ExtractFileExt(F));
            if AnsiContainsText('$.mp3$.mp2$', Ext) then
            begin
                    { Lecture TAG ID3 v1 }
                If Index <> 21 then MP3Tag := Lire_Tag(F);
                    { Lecture TAG ID3 v2 }
                If Index <> 12 then MP3Tag2.ReadFromFile(F);

                    { Enregistrement Simple }
                if Index = 0 then
                begin
                        { TAG ID3 v1 }
                    With MP3Tag do
                    begin
                      if CheckArtistv1.Checked then Artiste := LabelArtistv1.Text;
                      if CheckAlbumv1.Checked  then Album   := LabelAlbumv1.Text;
                      if CheckTitrev1.Checked  then Titre   := LabelTitrev1.Text;
                      if CheckAnneev1.Checked  then Annee   := LabelAnneev1.Text;
                      if CheckNbv1.Checked then
                      begin
                          if CheckAutoNbv1.Checked then
                              TrackNb := i + 1
                          else
                              TrackNb := StrToInt(LabelNbv1.Text);
                      end;
                      if CheckComv1.Checked    then Commentaire := LabelComv1.Text;
                      if CheckGenrev1.Checked  then Genre       := ComboGenrev1.ItemIndex;
                    end;
                        { TAG ID3 v2 }
                    With MP3Tag2 do
                    begin
                      if CheckArtistv2.Checked then Artist := LabelArtistv2.Text;
                      if CheckAlbumv2.Checked  then Album  := LabelAlbumv2.Text;
                      if CheckTitrev2.Checked  then Title  := LabelTitrev2.Text;
                      if CheckAnneev2.Checked  then Year   := LabelAnneev2.Text;
                      if CheckNbv2.Checked then
                      begin
                          if CheckAutoNbv2.Checked then
                              Track := i + 1
                          else
                              Track := StrToInt(LabelNbv2.Text);
                      end;
                      if CheckComv2.Checked   then Comment := LabelComv2.Text;
                      if CheckGenrev2.Checked then Genre   := ComboGenrev2.Text;
                    end;
                end else

                    { TAG ID3v1 -> v2 }
                if Index = 12 then
                begin
                        { TAG ID3 v2 }
                    With MP3Tag2 do
                    begin
                      Artist  := MP3Tag.Artiste;
                      Album   := MP3Tag.Album;
                      Title   := MP3Tag.Titre;
                      Year    := MP3Tag.Annee;
                      Track   := MP3Tag.TrackNb;
                      Comment := MP3Tag.Commentaire;
                      Genre   := GetGenreFromIndex(MP3Tag.Genre);
                    end;
                end else

                    { TAG ID3v2 -> v1 }
                if Index = 21 then
                begin
                        { TAG ID3 v1 }
                    With MP3Tag do
                    begin
                      Artiste     := MP3Tag2.Artist;
                      Album       := MP3Tag2.Album;
                      Titre       := MP3Tag2.Title;
                      Annee       := MP3Tag2.Year;
                      TrackNb     := MP3Tag2.Track;
                      Commentaire := MP3Tag2.Comment;
                      Genre       := GetIndexofGenre(MP3Tag2.Genre);
                    end;
                end;

                    { Ecriture TAG ID3 v1 }
                If Index <> 12 then Ecrire_Tag(F, MP3Tag);
                With Progression do Position := Position + 1;

                    { Ecriture TAG ID3 v2 }
                If Index <> 21 then MP3Tag2.SaveToFile(F);
                With Progression do Position := Position + 1;
            end;

            if AnsiContainsText('$.mpc$', Ext) and (Index = 0) then
            begin
                    { Lecture TAG ID3 v1 }
                MP3Tag := Lire_Tag(F);
                With MP3Tag do
                begin
                  if CheckArtistv1.Checked then Artiste := LabelArtistv1.Text;
                  if CheckAlbumv1.Checked  then Album   := LabelAlbumv1.Text;
                  if CheckTitrev1.Checked  then Titre   := LabelTitrev1.Text;
                  if CheckAnneev1.Checked  then Annee   := LabelAnneev1.Text;
                  if CheckNbv1.Checked then
                  begin
                      if CheckAutoNbv1.Checked then
                          TrackNb := i + 1
                      else
                          TrackNb := StrToInt(LabelNbv1.Text);
                  end;
                  if CheckComv1.Checked    then Commentaire := LabelComv1.Text;
                  if CheckGenrev1.Checked  then Genre       := ComboGenrev1.ItemIndex;
                end;
                    { Ecriture TAG ID3 v1 }
                Ecrire_Tag(F, MP3Tag);
                With Progression do Position := Position + 2;
            end;

            if AnsiContainsText('$.ogg$', Ext) and (Index = 0) then
            begin
                    { Lecture TAG OGG }
                OGGTag := LireInfosOGG(F);
                    { Enregistrement Simple }
                With OGGTag do
                begin
                  if CheckArtistv2.Checked then Artist := LabelArtistv2.Text;
                  if CheckAlbumv2.Checked  then Album  := LabelAlbumv2.Text;
                  if CheckTitrev2.Checked  then Title  := LabelTitrev2.Text;
                  if CheckAnneev2.Checked  then Date   := LabelAnneev2.Text;
                  if CheckNbv2.Checked then
                  begin
                      if CheckAutoNbv2.Checked then
                          Track := IntToStr(i + 1)
                      else
                          Track := LabelNbv2.Text;
                  end;
                  if CheckComv2.Checked   then Comment := LabelComv2.Text;
                  if CheckGenrev2.Checked then Genre   := ComboGenrev2.Text;
                end;
                    { Ecriture TAG OGG }
                EcrireInfosOGG(F, OGGTag);
                With Progression do Position := Position + 2;
            end;

                { Si le fichier tait en cours de lecture on continue }
            If Lect then Form1.LitFichier;

            Application.ProcessMessages;
        end;
    end;
    MP3Tag2.Free;

                { Mise  jours de la liste de lecture }
    Form1.MenuRefreshListeClick(nil);

    FormTag.Enabled  := True;
    BtnSave.Enabled  := True;
    BtnClose.Enabled := True;
    Btnv1v2.Enabled  := True;
    Btnv2v1.Enabled  := True;
    Screen.Cursor    := crDefault;
end;



end.
